# Summary

* [Introduction](README.md)
* [Tricks](tricks.md)
  * [Alphanumeric incrementing](tricks/alphanumeric-incrementing.md)
  * [Associative arrays](tricks/associative-arrays.md)
  * [At exit method](tricks/at-exit-method.md)
  * [Autovivification](tricks/autovivification.md)
  * [Blocks can take blocks](tricks/blocks-can-take-blocks.md)
  * [Bubbling up thread errors](tricks/bubbling-up-thread-errors.md)
  * [Case on ranges](tricks/case-on-ranges.md)
  * [Count all objects](tricks/count-all-objects.md)
  * [Cycle](tricks/cycle.md)
  * [Data](tricks/data.md)
  * [Easiest database pstore](tricks/easiest-database-pstore.md)
  * [Easiest database pstore yaml](tricks/easiest-database-pstore-yaml.md)
  * [Enable garbage collector profiler](tricks/enable-garbage-collector-profiler.md)
  * [Enable ruby warnings](tricks/enable-ruby-warnings.md)
  * [Fast memoization fibonacci](tricks/fast-memoization-fibonacci.md)
  * [Fetch data](tricks/fetch-data.md)
  * [Get random data](tricks/get-random-data.md)
  * [Head tail](tricks/head-tail.md)
  * [Inject](tricks/inject.md)
  * [Inspecting the source with script lines](tricks/inspecting-the-source-with-script-lines.md)
  * [Iterating over specific types](tricks/iterating-over-specific-types.md)
  * [Lambda your own syntax](tricks/lambda-your-own-syntax.md)
  * [Memoization](tricks/memoization.md)
  * [Print formatted with debug](tricks/print-formatted-with-debug.md)
  * [Ruby debug flag](tricks/ruby-debug-flag.md)
  * [Shortcut variable interpolation](tricks/shortcut-variable-interpolation.md)
  * [Single instance running](tricks/single-instance-running.md)
  * [Smalltalk conditionals](tricks/smalltalk-conditionals.md)
  * [Splat operator](tricks/splat-operator.md)
  * [Stab operator](tricks/stab-operator.md)
  * [Struct without assignment](tricks/struct-without-assignment.md)
  * [Super magic keyword](tricks/super-magic-keyword.md)
  * [Super magic keyword2](tricks/super-magic-keyword2.md)
  * [Super magic keyword3](tricks/super-magic-keyword3.md)
  * [Super magic keyword4](tricks/super-magic-keyword4.md)
  * [Super magic keyword5](tricks/super-magic-keyword5.md)
  * [Tail call](tricks/tail-call.md)
  * [Trigger irb as needed](tricks/trigger-irb-as-needed.md)
  * [Unfreeze objects with fiddle](tricks/unfreeze-objects-with-fiddle.md)
  * [Unused variable format](tricks/unused-variable-format.md)
  * [Variables from a regex](tricks/variables-from-a-regex.md)
  * [Zip](tricks/zip.md)
  * [Introspecting Block Parameters](tricks/introspecting_block_parameters.md)
* [Idiomatic Ruby](idiomatic_ruby.md)
  * [Each vs map](idiomatic_ruby/each_vs_map.md)
  * [Conditional assignment](idiomatic_ruby/conditional_assignment.md)
  * [Combine operation over collections (enumerables)](idiomatic_ruby/combine_elements_in_collection.md)
  * [Array of Strings or Symbols](idiomatic_ruby/array_of_strings_symbols.md)
  * [Multiple Assignment](idiomatic_ruby/multiple_assignment.md)
  * [Use Symbol to_proc](idiomatic_ruby/use_symbol_to_proc.md)
  * [Array Sample (enumerables)](idiomatic_ruby/array_sample.md)
  * [Use Fixnum#times](idiomatic_ruby/use_times.md)
  * [Implicit Return](idiomatic_ruby/implicit_return.md)
* [Refactorings](refactorings.md)
  * [Conditionals when object is nil](refactorings/conditionals_when_object_is_nil.md)
  * [Switch case with Hashes](refactorings/case_with_hashes.md)
* [Best Practices](best_practices.md)
  * [rescue => Exception e](best_practices/using_exception_e.md)
